#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cerrno>

#include <unistd.h>

#include <string>
#include <iostream>

#include "music.h"
#include "m_opl.h"

static int nop = 70; // nopeus

static musicdriver *drv;

static int upper2(int a)
{
	if(a==''||a==''||a==''||a=='{')return '';
	if(a==''||a==''||a==''||a=='|')return '';
	if(a>='a' && a<='z')return a-32;
	return a;
}

static InternalSample Inst[256];
static void LoadData(void)
{
	BYTE *s;
	long size=0;
	unsigned a;

	FILE *fp = fopen("adlpuhu.dat", "rb");
	if(!fp)return;
	fseek(fp, 0, SEEK_END);
	size=ftell(fp);
	rewind(fp);
	
	BYTE *buf = new BYTE[size];
	
	fread(buf, size, 1, fp);
	fclose(fp);
	
	s = buf;
	if(s[1] > 2)
		for(;*s++;);
	
	InternalHdr Hdr = *(InternalHdr *)s;
	
	s += (Hdr.PatNum&512) ? 11 : 10;
	s += Hdr.OrdNum&255;
	
	for(a=0; a<Hdr.InsNum; a++)
	{
		InternalSample *smp = (InternalSample *)s;
		s += sizeof(*smp);
		
		if(Hdr.PatNum&512)
		{
			cout << s << endl;
			s += strlen((char *)s)+1;
		}
		
		unsigned char diu = smp->GM;
		if(diu == 142)diu = '';
		if(diu == 153)diu = '';
		
		// '|' = suhu-s
		
 		Inst[diu] = *smp;
	}
	free(buf);
}

static unsigned c4spd(unsigned char insnum)
{
	return Inst[insnum].C4Spd;
}

static BYTE *adldata(unsigned char insnum)
{
	return Inst[insnum].D;
}

static void stradd(char *s, unsigned n)
{
	char *p = strchr(s, 0);
	while(p > s)
	{
		p[n] = *p;
		--p;
	}
}

static const string Voka    = "AEIOUY";
static const string Konso   = "BCDFGHJKLMNPQRSTVWXZ";
static const string Molemmat= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
static const string Kovat   = "BDGKPQT";
static const string Kovat2  = "BDGKPQTXZ";

static void SubSano(char *s)
{
	int F = 0;

	for(; *s; ++s)
	{
		unsigned c = 80; /* viivemuuttuja */

		if(*s >= '0' && *s <= '9')
		{
			cout << *s;
			F = 50 + (*s - '0');
			continue;
		}

#if 0
		/* Savoa? */
		if(s[1]=='A' && s[2]=='A')s[1]='U';
		if(s[1]=='I'&&s[2])s[1]='J';
		if(*s=='D')*s='R';
#endif
		
		cout << *s;

		while(*s==s[1] && Kovat2.find(*s) != Kovat2.npos)
		{
			drv->noteoff(0);
			
			drv->delay(1400*nop);
			
		//	cout << *s;
			
			s++;
		}

		if(*s=='X')
		{
			stradd(s, 1);
			s[0]='K';
			s[1]='S';
		}
		if(*s=='Z')
		{
			stradd(s, 1);
			s[0]='T';
			s[1]='S';
		}

		if(*s=='K' && s[1]=='S')
		{
			drv->noteoff(0);
			drv->delay(400*nop);
		}
		if((unsigned char)*s >= 'A')
		{
		//	cout << "\33[1m" << *s << "\33[m";			
			drv->patch(0, 0, 0, c4spd(*s), adldata(*s));
			drv->noteon(0, F, 55);
		}
		else
		{
			drv->noteoff(0); // cout << '.';
			c = 40;
		}
		
		if(Kovat.find(*s) != Kovat.npos)
		{
			drv->delay(400*nop);
			drv->noteoff(0); // cout << '.';
			c += (s[1] && s[1] <= ' ') ? 40 : -40;
		}
		
		if(Voka.find(*s) != Voka.npos)c += 20;

		drv->delay(10*c*nop);

		if(s[1] != *s || Voka.find(*s) == Voka.npos)
		{
			drv->noteoff(0);
			// cout << '.';
		}
		
#if 0		
		if(Voka.find(s[0]) != Voka.npos
		&& Voka.find(s[1]) == Voka.npos)
			++F;
		else
			--F;
#endif
	}
}

static bool Stop(int c)
{
	return strchr(".,:;-\r\n?!", c) != NULL;
}

static string GetByte(const char *&p)
{
	while(*p && Molemmat.find(*p) == Molemmat.npos)++p;
	
	string Buf;
	
	while(Konso.find(*p) != Konso.npos)Buf += *p++;
	while(Voka.find(*p) != Voka.npos)Buf += *p++;
	while(Konso.find(*p) != Konso.npos)
	{
		if(Voka.find(p[1]) != Voka.npos)break;
		Buf += *p++;
	}
	while(*p==' ')++p;	
	return Buf;
}

static void SPuhu(const char *s)
{
	string Buf;
	
	for(; *s; ++s)
		if(*s != '"')
			Buf += upper2(*s);
	
	const char *p = Buf.c_str();

	for(;;)
	{
		string t = GetByte(p);
		if(!t.size())break;
		
		char c = Stop(*p) ? ' ' : '-';
		
		string tmp = (Stop(*p) ? '2' : '7') + t;
		
		char Buf2[64];
		strcpy(Buf2, tmp.c_str());
		SubSano(Buf2);
		
		if(Stop(*p))
		{
			cout << " -";
			drv->delay(1400*nop);
		}
		cout << c;
	}

//	SubSano(Buf, sizeof Buf);

	cout << endl;
}

static void Puhu(string s)
{
	SPuhu(s.c_str());
}

int main(void)
{
	registerdrivers(&OPLDriver, NULL);
	drv = finddriver('o');
	
	if(drv->detect() < 0)
	{
		cerr << "Sound card not detected.\n";
		if(geteuid())cerr << "You should be root, we use adlib with direct port io.\n";
		return ENODEV;
	}
	drv->reset();
	
	LoadData();
	
	for(;;)
	{
		string s;
		getline(cin, s);
		if(!cin.good())break;
		
		Puhu(s);
	}

	return 0;
}
